import pyglet, random
from pyglet.gl import *
from sprites import flyer_s

class map_block_obj(object):
    label = None
    block_image = None
    flyer = None
    
class info_X_Y(object):
    def __init__(self, batch):
        self.batch = batch
        
#        self.mark_x_y_long_list = self.mark_x_y_long()
#        self.mark_x_y_list = self.mark_x_y()
        self.point_x_y_list = self.point_x_y()
        self.small_point_x_y_list = []
        self.label_text_list = self.label_text()
        self.grass = ( pyglet.resource.image('static/grass_1.gif'),
            pyglet.resource.image('static/grass_2.gif'),
            pyglet.resource.image('static/grass_3.gif'),
            pyglet.resource.image('static/grass_4.gif') )
#        self.grass_list = []
        self.map_block_obj_list = [] 
        self.make_map_block_obj_list()
        self.small_point_x_y()
        
        
#    def mark_x_y_long(self):
#        return (['a', 'b', 'c', 'b', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p'],
#            ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P'])
#    def mark_x_y(self):
#        return (['a', 'b', 'c', 'b', 'e', 'f', 'g'],
#             ['A', 'B', 'C', 'D', 'E', 'F', 'G'])

    def point_x_y(self):
        return ((0,0), (200,0), (400,0),
                (0,200), (200,200), (400,200),
                (0,400), (200,400), (400,400))
    
    def small_point_x_y(self, start_x = 610, start_y = 410):
        for y in range(0, 7):
            for x in range(0, 7):
                self.small_point_x_y_list.append(((x * 25) + start_x, (y * 25) + start_y))
           
    def label_text(self):
        return ('aA', 'aB', 'aC', 'aD', 'aE', 'aF', 'aG',
                'bA', 'bB', 'bC', 'bD', 'bE', 'bF', 'bG',
                'cA', 'cB', 'cC', 'cD', 'cE', 'cF', 'cG',
                'dA', 'dB', 'dC', 'dD', 'dE', 'dF', 'dG',
                'eA', 'eB', 'eC', 'eD', 'eE', 'eF', 'eG',
                'fA', 'fB', 'fC', 'fD', 'fE', 'fF', 'fG',
                'gA', 'gB', 'gC', 'gD', 'gE', 'gF', 'gG')
    
    def make_map_block_obj_list(self):
        for n in range(0, 49):
            mbj = map_block_obj()
            grass_n = random.randint(0, 3)
#            self.grass_list.append(self.grass[grass_n])
            mbj.block_image = self.grass[grass_n]
            mbj.label = self.label_text_list[n]
            mbj.flyer = flyer_s()
#            if random.randint(0,10) == 1:
#                mbj.flyer.alive = True
            self.map_block_obj_list.append(mbj) 
    
#    def get_n_from_screen_list(self, n, start_x=0, start_y=0):
#        y = n // 3 + start_y
#        x = n % 3 + start_x
#        return y * 7 + x
    
    def package_screen_list(self, start_x=0, start_y=0):
        # Drop the flyer out of screen.
        for n in range(0, 49):
            if self.map_block_obj_list[n].flyer:
                self.map_block_obj_list[n].flyer.x = -1000
                self.map_block_obj_list[n].flyer.y = -1000
        self.package_list = []   
        for n in range(0,9):
            y = n // 3 + start_y
            x = n % 3 + start_x
            list_n = y * 7 + x
            # maybe have bug in here.
            o = self.map_block_obj_list[list_n]
            if o.flyer.alive:
                o.flyer.x = self.point_x_y_list[n][0] + random.randint(0, 200)
                o.flyer.y = self.point_x_y_list[n][1] + random.randint(0, 200)
#                o.flyer.batch = self.batch
            self.package_list.append(o)